#include <3048f.h>

void	SyncSetup(void)	/* ^C}̃ZbgAbv */
{
	ITU.TMDR.BYTE = 0x0f;	/* ch0-ch3 PWM mode */
	ITU.TSNC.BYTE = 0x0d;	/* ch0,ch2,ch3𓯊 */
	
	/* channel 0: HSYNC */
	ITU0.TCR.BYTE = 0xa0;	/* GRÄvŃNA 1/1 clock */
	ITU0.TIOR.BYTE = 0x9a;	/* TIOAC0ɏo */
	ITU0.GRA = 455;		/* 28.444usɑ΂JEgl 455 */
	ITU0.GRB = 32;		/* oX 2usec */
	
	/* channel 1: VSYNC */
	ITU1.TCR.BYTE = 0xa6;	/* clear by GRA, input TCLKC +edge */
	ITU1.TIOR.BYTE = 0x9a;	/* TIOAC1ɏo */
	ITU1.GRA = 625;			/*  */
	ITU1.GRB = 3;			/* oX 0.18usec */
	
	/* channel 2: HSYNC back poach */
	ITU2.TCR.BYTE = 0xe0;	/* ch0ɓ */
	ITU2.GRA = 0;
	ITU2.GRB = 90;		/* (2 + 3.6)*16 */
	
	/* channel 3: HSYNC front poach */
	ITU3.TCR.BYTE = 0xe0;	/* ch0ɓ */
	ITU3.GRA = 0;
	ITU3.GRB = 444;		/* 4550.7usecl */
	
	ITU.TSTR.BYTE = 0x0f;	/* ^C}[X^[g */
}

main()
{
	short	n;
	
	P4.DDR = 0x0f;/* LIST 2̎ŝ߂̃|[gݒ */
	SyncSetup();	/* ^C}̏ݒ */
	for( ; ; ){	/* MoȂ炱̃[vł悢 */
		;/* Ȃ */
	}
	/* LIST 2 J[o[16fĴ߂̃[v */
	for( ; ; ){
		n = ITU1.TCNT;
		if(n < 172)	/* 150ɃobNE|[`22 */
			P4.DR.BYTE = 1;
		else if(n < 322)
			P4.DR.BYTE = 2;
		else if(n < 472)
			P4.DR.BYTE = 4;
		else /* 473 - */ 
			P4.DR.BYTE = 8;
	}
	/* LIST 3 K͗lo߂̃[v */
	DA.CR.BYTE = 0x5f;	/* D-ARo[^`l0ݒ */
	for( ; ; ){
		/*DA.DR0 = ITU0.TCNT;*/	/* HSYNC */
		DA.DR0 = ITU1.TCNT;		/* VSYNC */
	}
}
