#include <3048f.h>
short	ktime;/* c莞ԁ@PʁFb */
unsigned char	pattern[12][15];/* `f[^̃obt@ */

unsigned char	numFont[][7][5] = {/* 5~7hbg̐tHg */
	{/* '0' */
		{0,1,1,1,0},
		{1,0,0,0,1},
		{1,0,0,1,1},
		{1,0,1,0,1},
		{1,1,0,0,1},
		{1,0,0,0,1},
		{0,1,1,1,0}
	},
	
	{/* '1' */
		{0,0,1,0,0},
		{0,1,1,0,0},
		{0,0,1,0,0},
		{0,0,1,0,0},
		{0,0,1,0,0},
		{0,0,1,0,0},
		{0,1,1,1,0}
	},

	{/* '2' */
		{0,1,1,1,0},
		{1,0,0,0,1},
		{0,0,0,0,1},
		{0,0,0,0,1},
		{0,0,0,1,0},
		{0,0,1,0,0},
		{1,1,1,1,1}
	},

	{/* '3' */
		{1,1,1,1,1},
		{0,1,0,0,0},
		{0,0,1,0,0},
		{0,0,0,1,0},
		{0,0,0,0,1},
		{1,0,0,0,1},
		{0,1,1,1,0}
	},

	{/* '4' */
		{0,0,0,1,0},
		{0,0,1,1,0},
		{0,1,0,1,0},
		{1,0,0,1,0},
		{1,1,1,1,1},
		{0,0,0,1,0},
		{0,0,0,1,0}
	},

	{/* '5' */
		{1,1,1,1,1},
		{1,0,0,0,0},
		{1,1,1,1,0},
		{0,0,0,0,1},
		{0,0,0,0,1},
		{1,0,0,0,1},
		{0,1,1,1,0}
	},

	{/* '6' */
		{0,0,1,1,0},
		{0,1,0,0,0},
		{1,0,0,0,0},
		{1,1,1,1,0},
		{1,0,0,0,1},
		{1,0,0,0,1},
		{0,1,1,1,0}
	},

	{/* '7' */
		{1,1,1,1,1},
		{0,0,0,0,1},
		{0,0,0,1,0},
		{0,0,1,0,0},
		{0,1,0,0,0},
		{0,1,0,0,0},
		{0,1,0,0,0}
	},

	{/* '8' */
		{0,1,1,1,0},
		{1,0,0,0,1},
		{1,0,0,0,1},
		{0,1,1,1,0},
		{1,0,0,0,1},
		{1,0,0,0,1},
		{0,1,1,1,0}
	},

	{/* '9' */
		{0,1,1,1,0},
		{1,0,0,0,1},
		{1,0,0,0,1},
		{0,1,1,1,1},
		{0,0,0,0,1},
		{0,0,0,1,0},
		{0,1,1,0,0}
	}
};

void	upperDigit(char n)/* 10̈ʂ̕\ */
{
	unsigned char	*p,*q;
	short	x,y;
	
	if(n == 0){
		for(y = 0; y < 7; y++){/* 0ȂΔ\ */
			p = pattern[y + 2];
			for(x = 0; x < 5; x++)
				*p++ = 0;
		}
	}
	else{
		q = numFont[n][0];/* tHg̃f[^obt@ */
		for(y = 0; y < 7; y++){
			p = pattern[y + 2];
			for(x = 0; x < 5; x++)
				*p++ = *q++;
		}
	}
}

void	lowerDigit(char n)/* 1̈ʂ̕\ */
{
	unsigned char	*p,*q;
	short	x,y;
	
	q = numFont[n][0];
	for(y = 0; y < 7; y++){/* tHg̃f[^obt@ */
		p = pattern[y + 2] + 6;
		for(x = 0; x < 5; x++)
			*p++ = *q++;
	}
}

void	TimeDisplay(short s)/* c莞Ԃ̕\ */
{
	if(s >= 60)/* 60bȏ͕\ */
		s /= 60;
	upperDigit(s/10);/* 10̈ */
	lowerDigit(s%10);/* 1̈ */
}


void	SyncSetup(void)	/* ^C}̃ZbgAbv */
{
	ITU.TMDR.BYTE = 0x0f;	/* ch0-ch3 PWM mode */
	ITU.TSNC.BYTE = 0x0d;	/* ch0,ch2,ch3𓯊 */
	
	/* channel 0: HSYNC */
	ITU0.TCR.BYTE = 0xa0;	/* GRÄvŃNA 1/1 clock */
	ITU0.TIOR.BYTE = 0x9a;	/* TIOAC0ɏo */
	ITU0.GRA = 455;		/* 28.444usɑ΂JEgl 455 */
	ITU0.GRB = 32;		/* oX 2usec */
	
	/* channel 1: VSYNC */
	ITU1.TCR.BYTE = 0xa6;	/* clear by GRA, input TCLKC +edge */
	ITU1.TIOR.BYTE = 0x9a;	/* TIOAC1ɏo */
	ITU1.GRA = 625;			/*  */
	ITU1.GRB = 3;			/* oX 0.18usec */
	
	/* channel 2: HSYNC back poach */
	ITU2.TCR.BYTE = 0xe0;	/* ch0ɓ */
	ITU2.GRA = 0;
	ITU2.GRB = 90;		/* (2 + 3.6)*16 */
	
	/* channel 3: HSYNC front poach */
	ITU3.TCR.BYTE = 0xe0;	/* ch0ɓ */
	ITU3.GRA = 0;
	ITU3.GRB = 444;		/* 4550.7usecl */
	
	ITU.TSTR.BYTE = 0x0f;	/* ^C}[X^[g */
}

main()/* CEvO */
{
	unsigned char c,*p;
	short	m,n;
	short	vcount,phight;
	
	P2.PCR.BYTE = 0xff;/* |[g2vAbv */
	P3.DDR =0x1;	/* Buzzer */
	P4.DDR = 0x01;	/* |[g4̃rbg0o͂ */
	c = ~P2.DR.BYTE;/* Ԑݒ̃XCb`̏Ԃǂ */
	ktime =  c&0x0f;/* 1̈ */
	c >>= 4;
	c &= 0x0f;/* 10̈ʂ̃f[^4rbgɃVtg */
	ktime += 10*c;
	ktime *= 60;/* bɒktimeɃXgA */
	SyncSetup(); /* ^C}̃ZbgAbv */
	vcount = 0;/* ̃JE^ */
	for( ; ; ){
		n = 0;
		phight = 0;
		if(++vcount == 56){/* 561bo */
			vcount = 0;
			if(ktime != 0){/* c莞Ԃ-1 */
				ktime--;
				TimeDisplay(ktime);/* c莞Ԃ̕\ */
			}
			else{/* c莞Ԃ0̂Ƃ̓uU[Iɖ炷 */
				if(P3.DR.BIT.B0 == 0)
					P3.DR.BIT.B0 = 1;
				else
					P3.DR.BIT.B0 = 0;
			}
		}
		for( ; ITU1.TCNT < 22; )/* uLOԂ҂ */
			;
		for( ; ; ){/* 1tB[h̕` */
			p = &pattern[n][0];
			for( ; PA.DR.BIT.B6 != 0; )/* TIOCA2ɂobNE|[`o */
				;
			for(m = 0; m < 15; m++) /* obt@̃f[^PxMƂďo */
				P4.DR.BYTE = *p++;
			if(++phight == 54){/* p^[̏c54sNZ */
				n++;
				phight = 0;
			}
			if(ITU1.TCNT == 625)/* 胉C`悵烋[v𔲂 */
				break;
			for( ; PB.DR.BIT.B0 == 0; )/* TIOAC3ɂtgE|[`o */
				;
		}
	}
}

